import os          
import sys

""" Have to import vtk from command line script to make sure vtk output works"""

def setVTKPaths():
    import sys
    from os import environ
    import string
    import sys
    platform=sys.platform
    if platform=='win32':
        sys.path.append(environ["VTKPATH"])
        sys.path.append(environ["VTKPATH1"])
        sys.path.append(environ["PYQT_PATH"])
        sys.path.append(environ["SIP_PATH"])
        sys.path.append(environ["SIP_UTILS_PATH"])
#    else:
#        swig_path_list=string.split(environ["VTKPATH"])
#        for swig_path in swig_path_list:
#            sys.path.append(swig_path)

# print "PATH=",sys.path
setVTKPaths()
# print "PATH=",sys.path  

import vtk     

from os import environ
sys.path.append(environ["PYTHON_MODULE_PATH"])
sys.path.append(os.environ["SWIG_LIB_INSTALL_DIR"])
import CompuCellSetup
from CMLParser import CMLParser
          
try:
     from xml.parsers.expat import ExpatError
     
     import re
     from os import environ
     import string
     import traceback
     CompuCellSetup.playerType="CML"
     
     cmlParser=CompuCellSetup.cmlParser
     # CMLParser()
     cmlParser.processCommandLineOptions()
     CompuCellSetup.simulationPaths=CompuCellSetup.SimulationPaths()    
     
     # will set a directory where one may want to save simulation results
     if cmlParser.customScreenshotDirectoryName!="":
          CompuCellSetup.simulationPaths.setSimulationResultStorageDirectory(cmlParser.customScreenshotDirectoryName,False)
     
     
     fileName=cmlParser.getSimulationFileName()
     # will set a directory where one may want to save simulation results
     if cmlParser.customScreenshotDirectoryName=="":
          CompuCellSetup.simulationPaths.setSimulationResultStorageDirectory(fileName,True)
     
     if re.match(".*\.xml$", fileName): # If filename ends with .xml
          print "GOT FILE ",fileName
                
          pythonScriptName=CompuCellSetup.ExtractPythonScriptNameFromXML(fileName)
          CompuCellSetup.simulationPaths.setPlayerSimulationXMLFileName(fileName)
          if pythonScriptName!="":
                CompuCellSetup.simulationPaths.setPythonScriptNameFromXML(pythonScriptName) 
     elif re.match(".*\.py$", fileName):     
          # NOTE: extracting of xml file name from python script is done during script run time so we cannot use CompuCellSetup.simulationPaths.setXmlFileNameFromPython function here
          CompuCellSetup.simulationPaths.setPlayerSimulationPythonScriptName(fileName)
    
    
     sim,simthread = CompuCellSetup.getCoreSimulationObjects(True)
     # CompuCellSetup.cmlFieldHandler.outputFrequency=cmlParser.outputFrequency          

     
     if CompuCellSetup.simulationPaths.simulationPythonScriptName != "":
          # fileObj=file(CompuCellSetup.simulationPaths.simulationPythonScriptName,"r")
          # exec fileObj
          # fileObj.close()
          execfile(CompuCellSetup.simulationPaths.simulationPythonScriptName)
     else:
          sim,simthread = CompuCellSetup.getCoreSimulationObjects()
          # CompuCellSetup.cmlFieldHandler.outputFrequency=cmlParser.outputFrequency          
          import CompuCell #notice importing CompuCell to main script has to be done after call to getCoreSimulationObjects()
          #import CompuCellSetup

          CompuCellSetup.initializeSimulationObjects(sim,simthread)
          steppableRegistry = CompuCellSetup.getSteppableRegistry()
          CompuCellSetup.mainLoop(sim,simthread,steppableRegistry) # main loop - simulation is invoked inside this function

except IndentationError,e:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     traceback_message=traceback.format_exc()
     print traceback_message
     print "Indentation Error"+e.message
except SyntaxError,e:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     traceback_message=traceback.format_exc()
     print traceback_message
     print "Syntax Error"+e.message
except IOError,e:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     traceback_message=traceback.format_exc()
     print traceback_message
     print "IOerror Error"+e.message
except ImportError,e:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     traceback_message=traceback.format_exc()
     print traceback_message
     print "import Error"+e.message
except ExpatError,e:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     xmlFileName=CompuCellSetup.simulationPaths.simulationXMLFileName
     print "Error in XML File","File:\n "+xmlFileName+"\nhas the following problem\n"+e.message


except AssertionError,e:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     print "Assertion Error: ",e.message
except CompuCellSetup.CC3DCPlusPlusError,e:
     print "RUNTIME ERROR IN C++ CODE: ",e.message
except:
     if CompuCellSetup.simulationObjectsCreated:
          sim.finish()
     traceback_message=traceback.format_exc()
     print "Unexpected Error:",traceback_message

